package com.ippon.pouet;

import com.tngtech.archunit.core.domain.JavaClasses;
import com.tngtech.archunit.core.importer.ClassFileImporter;
import com.tngtech.archunit.core.importer.ImportOption;
import org.junit.jupiter.api.Test;

import static com.tngtech.archunit.lang.syntax.ArchRuleDefinition.noClasses;

class ArchTest {

    @Test
    void servicesAndRepositoriesShouldNotDependOnWebLayer() {

        JavaClasses importedClasses = new ClassFileImporter()
            .withImportOption(ImportOption.Predefined.DO_NOT_INCLUDE_TESTS)
            .importPackages("com.ippon.pouet");

        noClasses()
            .that()
                .resideInAnyPackage("com.ippon.pouet.service..")
            .or()
                .resideInAnyPackage("com.ippon.pouet.repository..")
            .should().dependOnClassesThat()
                .resideInAnyPackage("..com.ippon.pouet.web..")
        .because("Services and repositories should not depend on web layer")
        .check(importedClasses);
    }
}
